using System;
using System.ComponentModel.DataAnnotations.Schema;

namespace IRaCIS.Core.Domain.Models
{
    [Table("PaymentAdjustment")]
    public partial class PaymentAdjustment : BaseFullAuditEntity
    {
        public Guid ReviewerId { get; set; }

        public DateTime YearMonthDate { get; set; }
        public string YearMonth { get; set; }

        [Column(TypeName = "decimal(18,2)")]
        public decimal AdjustmentUSD { get; set; }

        [Column(TypeName = "decimal(18,4)")]
        public decimal AdjustmentCNY { get; set; }


        public Guid TrialId { get; set; } = Guid.Empty;

        [Column(TypeName = "decimal(18,2)")]
        public decimal ExchangeRate { get; set; }
        public bool IsLock { get; set; } = false;
        public string Note { get; set; } = string.Empty;

    }
}
